/* --------------------------------------------------------- */
/*	SCC test ( 1chipMSX only!! )							 */
/* ========================================================= */
/*	2006/11/25	t.hara										 */
/* --------------------------------------------------------- */

#include <stdio.h>
#include <msx/msx.h>

/* --------------------------------------------------------- */
static const unsigned int tone_freq[] = {

	/* C4     D4     E4     F4     G4     A4     B4     C5  end mark */
	0x1AC, 0x17D, 0x153, 0x140, 0x11D, 0x0FE, 0x0E3, 0x0D6, 0, 0,
};

static const signed char wave1[] = {

	0xFF, 0xEE, 0xDD, 0xCC, 0xBB, 0xAA, 0x99, 0x88, 0x77, 0x66, 0x55, 0x44, 0x33, 0x22, 0x11, 0x00,
	0x00, 0x11, 0x22, 0x33, 0x44, 0x55, 0x66, 0x77, 0x88, 0x99, 0xAA, 0xBB, 0xCC, 0xDD, 0xEE, 0xFF,
};

static const signed char wave2[] = {

	0xFF, 0xFE, 0xBB, 0x99, 0x66, 0x22, 0x11, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
};

/* --------------------------------------------------------- */
static void wait( int j ) {
	volatile int i;

	for( i = 0; i < j; i++ ) {
	}
}

/* --------------------------------------------------------- */
static void scc1_init( void ) {
	char ppi_port_a;

	/* SLOT ̃ZN^lǂݍ */
	ppi_port_a = inport( 0xA8 );

	/* y[W1, 2  SLOT1 ɐ؂ւ */
	ppi_port_a = (ppi_port_a & 0xC3) | 0x14;
	outport( 0xA8, ppi_port_a );

	/* J[gbW̃oNWX^ SCC ɃZbg */
	poke( 0xBFFE, 0 );
	poke( 0x9000, 0x3F );
}

/* --------------------------------------------------------- */
static void scc2_init( void ) {
	char ppi_port_a;

	/* SLOT ̃ZN^lǂݍ */
	ppi_port_a = inport( 0xA8 );

	/* y[W1, 2  SLOT1 ɐ؂ւ */
	ppi_port_a = (ppi_port_a & 0xC3) | 0x28;
	outport( 0xA8, ppi_port_a );

	/* J[gbW̃oNWX^ SCC ɃZbg */
	poke( 0xBFFE, 0 );
	poke( 0x9000, 0x3F );
}

/* --------------------------------------------------------- */
static void scc_play( void ) {
	int i;

	/* ch.A ̔g` */
	for( i = 0; i < 32; i++ ) {
		poke( 0x9800 + i, wave1[i] );
	}
	/* ch.A  */
	poke( 0x988A, 0x0F );

	for( i = 0; tone_freq[i] ; i++ ) {
		poke( 0x988F, 0x01 );
		poke( 0x9880, (unsigned char)tone_freq[i] );			/* freq. low */
		poke( 0x9881, (unsigned char)(tone_freq[i] >> 8) );		/* freq. high */
		wait( 5000 );
		poke( 0x988F, 0x00 );
		wait( 1000 );
	}
}

/* --------------------------------------------------------- */
static void scc12_play( void ) {
	int i;
	char scc1_slot, scc2_slot;

	scc1_slot = (inport( 0xA8 ) & 0xC3) | 0x14;
	scc2_slot = (inport( 0xA8 ) & 0xC3) | 0x28;

	/* ch.A ̔g` */
	outport( 0xA8, scc1_slot );
	for( i = 0; i < 32; i++ ) {
		poke( 0x9800 + i, wave1[i] );
	}
	/* ch.A  */
	poke( 0x988A, 0x0F );

	/* ch.A ̔g` */
	outport( 0xA8, scc2_slot );
	for( i = 0; i < 32; i++ ) {
		poke( 0x9800 + i, wave2[i] );
	}
	/* ch.A  */
	poke( 0x988A, 0x0F );

	outport( 0xA8, scc1_slot );
	for( i = 0; tone_freq[i] ; i++ ) {
		poke( 0x988F, 0x01 );
		poke( 0x9880, (unsigned char)tone_freq[i] );			/* freq. low */
		poke( 0x9881, (unsigned char)(tone_freq[i] >> 8) );		/* freq. high */

		outport( 0xA8, scc2_slot );
		poke( 0x988F, 0x01 );
		poke( 0x9880, (unsigned char)tone_freq[i + 2] );			/* freq. low */
		poke( 0x9881, (unsigned char)(tone_freq[i + 2] >> 8) );		/* freq. high */

		wait( 5000 );
		poke( 0x988F, 0x00 );

		outport( 0xA8, scc1_slot );
		poke( 0x988F, 0x00 );
		wait( 1000 );
	}
}

/* --------------------------------------------------------- */
int main( void ) {
	char ppi_port_a;

	ppi_port_a = inport( 0xA8 );
	printf( "%X\n", ppi_port_a );

	puts( "SLOT1" );
	scc1_init();	/* y[WPCQ SCC ɐ؂ւĂ̂ŁAՂ printf Ȃ */
	scc_play();
	outport( 0xA8, ppi_port_a );

	puts( "SLOT2" );
	scc2_init();
	scc_play();
	outport( 0xA8, ppi_port_a );

	puts( "SLOT1 AND 2" );
	scc12_play();
	outport( 0xA8, ppi_port_a );

	return 0;
}
